#pragma once
#include "constants.h"
#include <vector>
#include <bitset>
#include <unordered_set>
struct circle_s {
	int customer;
	double radius;
	double x, y;//Center of circle
	circle_s(int cust, double rad, double ex, double ey) :customer(cust), radius(rad), x(ex), y(ey){}
};

struct ip_s {
	double x, y;
	int i, j;//i and j are circle indices whose one intersection point is (x, y)
};


class Enumerate {
public:
	void enumerate_regions();
	void addcircle(struct circle_s& circle) { circles.push_back(circle); }
private:
	void clockwise_points(double x, double y, int two_t);
	void findip(struct circle_s* c1, struct circle_s* c2);
	void find_circles_intersection(int cust1, double x2, double y2, double r2, int tindex);
	std::vector<circle_s> circles;
	std::vector<ip_s> ips;//This will store the intersection points encountered. Does NOT check for uniqueness of intersection points.
	std::vector<std::pair<double, double> > TNbrIPs;//T neighbourhood intersection points.
	std::vector<int> TNbrIPsIndexClkWise;//Final index order of clockwise points
	std::vector<int> TNbrIPsIndexClkWiseQ1;
	std::vector<int> TNbrIPsIndexClkWiseQ2;
	std::vector<int> TNbrIPsIndexClkWiseQ3;
	std::vector<int> TNbrIPsIndexClkWiseQ4;
	std::vector<double> Qslopes;
	std::unordered_set<std::bitset<N>> TClusters_btst;
};

